// header file for defines

#ifndef DEFINES_H
#define DEFINES_H


#define _APPNAME "PatchWorks"
#define _VERSION "1.5"

#define PATCH_RES_DEFAULT	32	// Default Patch Resolution in pixels
#define PATCH_RES_MINIMUM	1
#define PATCH_RES_MAXIMUM	4104
#define PATCH_DPI_DEFAULT	100
#define PATCH_DPI_MINIMUM	10
#define PATCH_DPI_MAXIMUM	16000
#define COLORCOUNT_DEFAULT	100
#define TOLERANCE_DEFAULT	5.0	// tolerance for not properly matching patches
#define ASSESSMENT_MAX		765 // 3*255

#define FILELIST_END		"???END_OF_FILE_LIST???"
#define DB_INDEX_FILE		"DBindex.dbi"
#define DB_INDEX_VERSION	"PatchWorks DataBase Version 1\n"
#define DB_FILE_LEN			12	// img00001.bmp
#define INDEX_FILE_LINE		25	// bytes per line in DB index file
#define MAX_OPEN_DBs		10
#define MAX_IMAGES			99999 // max images per DB

// System Specific
#ifdef macintosh
#define DIR_SEP		":"
#define DIR_SEP_C	':'
#else
#define DIR_SEP		"/"
#define DIR_SEP_C	'/'
#endif



#define APP_LANG_EN // application language english
//#define APP_LANG_DE // application language german

// Errorcodes

// Prefix Syntax:
// Error:	er[x]_ with x = return code
// Info:	info_


#ifdef APP_LANG_EN

	#define APP_LANGUAGE			"english"

	#define eINTERNAL_ERROR			"\nUnexpected internal error. Please mail patchworks@caligamedia.de"
	#define eNO_MEMORY				"\nNot enough memory or other internal error."
	#define eNOT_A_DIR				"\nCould not access directory. May be not a valid path."
	#define eNOT_DELETED			"\nCould not delete file."
	#define eILLEGAL_RESOLUTION		"\nIllegal resolution."
	#define eUNSAVED_CHANGES		"\nUnsaved changes! Save, or reset changes (changed=0) to override."
	#define eSTART_PSEUDO			"\n\nStart calculation using %i colors\npatch width:\t%4i pixels\npatch height:\t%4i pixels\ncalculating..."
	#define eSTART_PATCHWORK		"\n\nStart calculation using %i DBs\npatch width:\t%4i pixels\npatch height:\t%4i pixels\ncalculating..."
	#define eWRITING_IMAGE			"\nwriting image %s ..."
	#define eTIME_ELAPSED			"\nElapsed time: %10.3lf seconds"
	#define eSTATISTICS				"\n\nStatistics:"
	#define eSTATISTIC_ONE			"\nUsed %5u of %5u patches in database \"%s\""
	#define eSTATISTIC_ALL			"\nUsed %5u of %5u patches in all databases ==\n"
	#define eSTATISTIC_AVGMM		"\naverage missmatch of patches: %6.2lf (%6.3lf%%)"
	#define eSTATISTIC_MINMM		"\nminimum missmatch of patches: %3i    (%6.3lf%%)"
	#define eSTATISTIC_MAXMM		"\nmaximum missmatch of patches: %3i    (%6.3lf%%)"

	#define err1 "\nNot enough parameters or wrong syntax"
	#define err2 "\nNot enough parameters for -deldb"
	#define err3 "\nDelete Database [y|n] :"
	#define err4 "\nDatabase already exists\n"
	#define err5 "\nParamter %i (Force) wrong syntax"
	#define err6 "\nReadIndexFile failure code %i"
	#define err7 "\nCreateIndexFile failure code %i"
	#define err8 "\nParameter \"%s\" not accepted"
	#define err9 "\nNot enough parameters for -subdb"
	#define err10 "\nDatabase item deleted"
	#define err11 "\nNot enough parameters for -adddb"
	#define err12 "\nReadImage failure code %i"
	#define err13 "\nScaleImage failure code %i"
	#define err14 "\nGetAverageColor failure code %i"
	#define err15 "\nWriteImage failure code %i"
	#define err16 "\nToo many parameters for pseudo patchwork"
	#define err17 "\nPseudoPatchwork created"
	#define err18 "\nTo many parameters ;)"
	#define err19 "\nDatabase closed"
	#define err20 "\nDatabase opened"
	#define err21 "\nDelete Database item? [y|n] :"
	#define err22 "\nDatabase item not deleted. (user abort)"
	#define err23 "\nCheck your parameter syntax!\nFor help type: %s /?"
////////////////////////////////////////////////////////////////////////////////	
	#define err24 eNO_MEMORY 
	#define err25 "\nFindFittingPatch failure code %i"
	#define err26 "\nNo DB in use"
	#define err27 "\nPatchwork successfully created"
	#define err28 "\nMore parameters given than expected."
	#define err29 "\nThe given Databases cannot be used together, because of different patch resolutions."
	#define err30 "\nTolerance Parameter could not be read!"
	#define err31 "\nTolerance Paramter was not between 0.0 and 100.0. Using default value. (%.3lf)"
	#define	err32 "Probably Wrong DataBase Version (%s).\nExpected: %s"

	#define err1_OpenDB "\nToo many DBs open"
	#define err2_OpenDB eNO_MEMORY
	#define err3_OpenDB eNOT_A_DIR

	#define err1_CloseDB "\nDB already closed or has not been in use"
	#define err2_CloseDB eUNSAVED_CHANGES
	#define err3_CloseDB "\nCloseDB failure code %i"

	#define err1_SaveDB "\nDB not in use. Cannot save."
	#define err2_SaveDB "\nNo changes to save."
	#define err3_SaveDB eNO_MEMORY
	#define err4_SaveDB eNOT_A_DIR
	#define err5_SaveDB eNOT_DELETED
	#define err6_SaveDB "\nCould not create index file."
	#define err0_SaveDB "\nDatabase has been successfully saved."

	#define err0_AddDB "\nDatbase has been created."
	#define err1_AddDB eILLEGAL_RESOLUTION
	#define err2_AddDB eNO_MEMORY
	#define err3_AddDB "\nDirectory already exists! Choose another name."
	#define err4_AddDB "\nCouldn't create directory!\nCheck HDD space and permissions. Or try a different name"

	#define err0_DeleteDB "\nDatabase has been deleted."
	#define err1_DeleteDB "\nDB not in use. Cannot close."
	#define err2_DeleteDB eUNSAVED_CHANGES
	#define err3_DeleteDB "\nCould not delete (all) items in folder."
	#define err4_DeleteDB "\nCould not remove folder."
	#define err9_DeleteDB "\nDatabase has not been deleted. (User abort)"

	#define err1_AddDBItem eNO_MEMORY
	#define err2_AddDBItem "\nIllegal database specified."
	#define err3_AddDBItem "\nDB is full."
	#define err4_AddDBItem eINTERNAL_ERROR
	#define err5_AddDBItem "\nadding: %s"
	#define err6_AddDBItem "\t\tError. Image not added."
	#define err9_AddDBItem "\nNot all images have been added:\nSome were corrupt or too small (upscale is currently not supported)"
	#define err0_AddDBItem "\nDatabase has been updated."

	#define err1_DeleteDBItem "\nError. Deleting DB Items is currently not supported."

	#define err1_GetAverageColor	"\nIncorrect size of imagedata: Size must be divisible by 3"

	#define info_DONT_EDIT			"Warning! Do not edit this file manually! Editing WILL make this DataBase worthless!"

	#define help "Syntax:\n\nCreate Patchwork:\nsource.bmp target.bmp TOLERANCE patchDB1 ... patchDB10\n(where TOLERANCE is 0.0 to 100.0)\n\nCreate Pseudopachwork:\nsource.bmp target.bmp pseudo [Colorcount [Resolution [y-Resolution]]]\n\nCreate New Database:\n-newdb [DBpath/]name [Resolution [y-Resolution [DPI]]]\n\nAdd item to Database:\n-addDB [DBpath/]name path[/xxxx.bmp]\n\nSubtract item from Database:\n-subDB [DBpath/]name path/xxxx.bmp [Force]\n\nDelete Database:\n-delDB [DBpath/]name [Force]\n\n"

#endif // english


#ifdef APP_LANG_DE

	#define APP_LANGUAGE			"deutsch"

	#define eINTERNAL_ERROR			"\nUnerwarteter interner Fehler. Bitte Nachricht an patchworks@caligamedia.de"
	#define eNO_MEMORY				"\nNicht genug Speicher oder interner Fehler."
	#define eNOT_A_DIR				"\nVerzeichnis konnte nicht geoeffnet werden. Ungueltiger Pfad?"
	#define eNOT_DELETED			"\nDatei konnte nicht geloescht werden."
	#define eILLEGAL_RESOLUTION		"\nUngueltige Aufloesung."
	#define eUNSAVED_CHANGES		"\nNicht gespeicherte Aenderungen! Speichern oder Aenderungen verwerfen (changed=0)."
	#define eSTART_PSEUDO			"\n\nBeginne Berechnung mit %i Farben\nPatchbreite:\t%4i Pixel\nPatchhoehe: \t%4i Pixel\nrechne..."
	#define eSTART_PATCHWORK		"\n\nBeginne Berechnung mit %i DBs\nPatchbreite:\t%4i Pixel\nPatchhoehe: \t%4i Pixel\nrechne..."
	#define eWRITING_IMAGE			"\nSchreibe Bild %s ..."
	#define eTIME_ELAPSED			"\nBenoetigte Zeit: %10.3lf Sekunden"
	#define eSTATISTICS				"\n\nStatistik:"
	#define eSTATISTIC_ONE			"\n%5u von %5u Patches verwendet in Datenbank \"%s\""
	#define eSTATISTIC_ALL			"\n%5u von %5u Patches in allen Datenbanken verwendet ==\n"
	#define eSTATISTIC_AVGMM		"\nDurchschn. Abweichung der Patches vom Idealwert: %6.2lf (%6.3lf%%)"
	#define eSTATISTIC_MINMM		"\nMinimale   Abweichung der Patches vom Idealwert: %3i    (%6.3lf%%)"
	#define eSTATISTIC_MAXMM		"\nMaximale   Abweichung der Patches vom Idealwert: %3i    (%6.3lf%%)"

	#define err1  "\nZu wenig Parameter oder falsche Syntax."
	#define err2  "\nZu wenig Parameter fuer -deldb"
	#define err3  "\nDatenbank loeschen? [y|n] :"
	#define err4  "\nDatenbank exists bereits.\n"
	#define err5  "\nParamter %i (Force): falsche Syntax"
	#define err6  "\nReadIndexFile Fehlercode %i"
	#define err7  "\nCreateIndexFile Fehlercode %i"
	#define err8  "\nParameter \"%s\" nicht akzeptiert"
	#define err9  "\nZu wenig Parameter fuer -subdb"
	#define err10 "\nDatenbankeintrag geloescht"
	#define err11 "\nZu wenig Parameter fuer -adddb"
	#define err12 "\nReadImage Fehlercode %i"
	#define err13 "\nScaleImage Fehlercode %i"
	#define err14 "\nGetAverageColor Fehlercode %i"
	#define err15 "\nWriteImage Fehlercode %i"
	#define err16 "\nZu viele Parameter fuer PseudoPatchwork."
	#define err17 "\nPseudoPatchwork erstellt."
	#define err18 "\nZu viele Parameter ;)"
	#define err19 "\nDatenbank geschlossen"
	#define err20 "\nDatenbank geoeffnet"
	#define err21 "\nDatenbankeintrag loeschen? [y|n] :"
	#define err22 "\nDatenbankeintrag nicht geloescht. (Abbruch durch Benutzer)"
	#define err23 "\nSyntax ueberpruefen!\nHilfe anzeigen: %s /?"
////////////////////////////////////////////////////////////////////////////////	
	#define err24 eNO_MEMORY
	#define err25 "\nFindFittingPatch Fehlercode %i"
	#define err26 "\nKeine Datenbank in Benutzung."
	#define err27 "\nPatchwork erfolgreich erstellt."
	#define err28 "\nMehr Parameter uebergeben als erwartet."
	#define err29 "\nDie angegebenen Datenbanken koennen nicht zusammen verwendet werden,\nda sie nicht die selbe Patchaufloesung verwenden."
	#define err30 "\nTolerance Parameter konnte nicht gelesen werden!"
	#define err31 "\nTolerance Paramter nicht zwischen 0.0 und 100.0. Verwende Standardwert (%.3lf)"
	#define	err32 "Wahrscheinlich falsche Datenbankversion (%s).\nErwartet: %s"

	#define err1_OpenDB "\nZu viele Datenbanken offen."
	#define err2_OpenDB eNO_MEMORY
	#define err3_OpenDB eNOT_A_DIR

	#define err1_CloseDB "\nDatenbank bereits geschlossen oder war nicht in Benutzung."
	#define err2_CloseDB eUNSAVED_CHANGES
	#define err3_CloseDB "\nCloseDB Fehlercode %i"

	#define err1_SaveDB "\nDatenbank wird nicht verwendet. Kann nicht speichern."
	#define err2_SaveDB "\nKeine Aenderungen zu speichern."
	#define err3_SaveDB eNO_MEMORY
	#define err4_SaveDB eNOT_A_DIR
	#define err5_SaveDB eNOT_DELETED
	#define err6_SaveDB "\nIndex Datei konnte nicht erstellt werden."
	#define err0_SaveDB "\nDatenbank erfolgreich gespeichert."

	#define err0_AddDB "\nDatenbank erstellt."
	#define err1_AddDB eILLEGAL_RESOLUTION
	#define err2_AddDB eNO_MEMORY
	#define err3_AddDB "\nVerzeichnis existiert bereits. Anderen Namen verwenden."
	#define err4_AddDB "\nVerzeicnis konnte nicht erstellt werden!\nVerfuegbaren Speicherplatz und Zugriffsrechte ueberpruefen oder anderen Namen waehlen."

	#define err0_DeleteDB "\nDatenbank wurde geloescht."
	#define err1_DeleteDB "\nDatenbank wird nicht verwendet und kann daher nicht geschlossen werden."
	#define err2_DeleteDB eUNSAVED_CHANGES
	#define err3_DeleteDB "\n(Nicht alle) Dateien im Verzeichnis konnten geloescht werden."
	#define err4_DeleteDB "\nVerzeichnis konnte nicht geloescht werden."
	#define err9_DeleteDB "\nDatenbank nicht geloescht. (Abbruch durch Benutzer)"

	#define err1_AddDBItem eNO_MEMORY
	#define err2_AddDBItem "\nUngueltige Datenbank angegeben."
	#define err3_AddDBItem "\nDatenbank ist voll."
	#define err4_AddDBItem eINTERNAL_ERROR
	#define err5_AddDBItem "\nverarbeite: %s"
	#define err6_AddDBItem "\t\tFehler. Bild nicht hinzugefuegt."
	#define err9_AddDBItem "\nNicht alle Bilder wurden hinzugefuegt:\n Manche waren zu klein (upscale momentan nicht unterstuetzt)"
	#define err0_AddDBItem "\nDatenbank wurde aktualisiert."

	#define err1_DeleteDBItem "\nFehler. Datenbankeintraege loeschen wird momentan nicht unterstuetzt."

	#define err1_GetAverageColor	"\nInterner Fehler: Imagedata ungueltig! Groesse muss durch 3 teilbar sein."

	#define info_DONT_EDIT			"Warning! Do not edit this file manually! Editing WILL make this DataBase worthless!"

	#define help "Syntax:\n\nPatchwork erstellen:\nsource.bmp target.bmp TOLERANCE patchDB1 ... patchDB10\n(where TOLERANCE is 0.0 to 100.0)\n\nPseudopachwork erstellen:\nsource.bmp target.bmp pseudo [Colorcount [Resolution [y-Resolution]]]\n\nNeue Datenbank anlegen:\n-newdb [DBpath/]name [Resolution [y-Resolution [DPI]]]\n\nBilder zu Datenbank hinzufuegen:\n-addDB [DBpath/]name path[/xxxx.bmp]\n\nBilder aus Datenbank loeschen:\n-subDB [DBpath/]name path/xxxx.bmp [Force]\n\nDatenbank loeschen:\n-delDB [DBpath/]name [Force]\n\n"

#endif // german



#endif