// header file for structures

#ifndef STRUCTS_H
#define STRUCTS_H

typedef unsigned long  ulong;
typedef unsigned short ushort;
typedef unsigned char uint8;
typedef unsigned int  uint; // normally 32 bit

typedef struct 
{
	uint  w;		// width  (pixels)
	uint  h;		// height (pixels)

	uint  xdpi;		// horizontal resolution
	uint  ydpi;		// vertical resolution

	uint8 avgc_r;	// average color r,g,b
	uint8 avgc_g;
	uint8 avgc_b;
	
	uint8 *data;
}sImage;

typedef struct 
{
	uint inuse;		// is this one in use?
	uint changed;	// are unsaved changes made? (DB index file)
	uint imgcount;	// images in the database
	uint res_w;		// x resolution of patches
	uint res_h;		// y resolution of patches
	uint dpi;		// DPI of patches in DB
	char *data;		// data in blocks of INDEX_FILE_LINE bytes
	uint *colordata;// average colors of patches (extractes from .data)
	uint *usecount;	// count how often a patch has been used
	char *path;		// path of the DataBase
}sDataBase;



#endif